1335. Minimum Difficulty of a Job Schedule

https://leetcode.com/problems/minimum-difficulty-of-a-job-schedule/

You want to schedule a list of jobs in d days. Jobs are dependent (i.e To work on the i-th job, you have to finish all the jobs j where 0 <= j < i).

You have to finish at least one task every day. The difficulty of a job schedule is the sum of difficulties of each day of the d days. The difficulty of a day is the maximum difficulty of a job done in that day.

Given an array of integers jobDifficulty and an integer d. The difficulty of the i-th job is jobDifficulty[i].

Return the minimum difficulty of a job schedule. If you cannot find a schedule for the jobs return -1.

Input: jobDifficulty = [6,5,4,3,2,1], d = 2
Output: 7
Explanation: First day you can finish the first 5 jobs, total difficulty = 6.
Second day you can finish the last job, total difficulty = 1.
The difficulty of the schedule = 6 + 1 = 7 

Example 2:

Input: jobDifficulty = [9,9,9], d = 4
Output: -1
Explanation: If you finish a job per day you will still have a free day. you cannot find a schedule for the given jobs.

Example 3:

Input: jobDifficulty = [1,1,1], d = 3
Output: 3
Explanation: The schedule is one job per day. total difficulty will be 3.

Example 4:

Input: jobDifficulty = [7,1,7,1,7,1], d = 3
Output: 15

Example 5:

Input: jobDifficulty = [11,111,22,222,33,333,44,444], d = 6
Output: 843

Constraints:

  • 1 <= jobDifficulty.length <= 300

  • 0 <= jobDifficulty[i] <= 1000

  • 1 <= d <= 10

N个工作,每个工作有难度值,让按序把它们安排在d天内且每天都必须安排工作,每天工作量按照工作难度值最大的算,整体工作量为把每天的工作量加起来,问满足以上条件后能安排的最少整体工作量是多少。因为要求按序安排工作,对于前i天和前j个工作,第j个工作必须安排在第i天,action为它和前面哪些工作组在一起分配到第i天,所以本质是个划分问题。遍历k,范围[i, j]因为前面i天每天都要有工作,i之前的不能分配到第i天。dp[i][j] 为前i天安排j个工作的最小整体工作量,等于min(dp[i][j], dp[i - 1][k - 1] + max(job[k, j])。

参考自

class Solution {
public:
    int minDifficulty(vector<int>& jobDifficulty, int d) {
        const int N = jobDifficulty.size();
        if (N < d) return -1; 
        vector<vector<int>> dp(d, vector<int>(N, 0));
        dp[0][0] = jobDifficulty[0];
        for (int j = 1; j < N; ++j) dp[0][j] = max(jobDifficulty[j], dp[0][j - 1]);
        for (int i = 1; i < d; ++i) {
            for (int j = i; j < N; ++j) {
                dp[i][j] = INT_MAX;
                for (int k = j, local_max = 0; k >= i; --k) {
                    local_max = max(local_max, jobDifficulty[k]);
                    dp[i][j] = min(dp[i][j], dp[i - 1][k - 1] + local_max);
                }
            }
        }
        return dp[d - 1][N - 1];
    }
};

Last updated